//+------------------------------------------------------------------+
//|                               Copyright  2016,   |
//|                                                cmillion@narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2016, http://cmillion.ru"
#property link      "cmillion@narod.ru"
#property strict
#property description ""
//--------------------------------------------------------------------*/
extern int     Stoploss             = 10,           //
               Takeprofit           = 10;           //
extern double  Lot                  = 0.10;         //
extern int     slippage             = 20;           // 
extern int     Magic                = 777888;

//-------------------------------------------------------------------- 
int OnInit()
{ 
   return(INIT_SUCCEEDED);
}
//-------------------------------------------------------------------
void OnTick()
{
   if (!IsTradeAllowed()) return;
   double OOP;
   int i,b=0,s=0,tip;
   if (ObjectFind("cm line")==-1)
   {
      ObjectCreate("cm line",OBJ_HLINE,0,0,High[1],0,0,0,0);                     
      ObjectSet   ("cm line",OBJPROP_WIDTH,2);
      ObjectSet   ("cm line",OBJPROP_COLOR, Blue);
   }
   double line = ObjectGet("cm line", OBJPROP_PRICE1);
   for (i=0; i<OrdersTotal(); i++)
   {    
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      { 
         if (OrderSymbol()==Symbol() && Magic==OrderMagicNumber())
         { 
            tip = OrderType(); 
            OOP = NormalizeDouble(OrderOpenPrice(),Digits);
            if (tip==OP_BUY)             
            {  
               b++;
               if (Close[1]<line && Open[1]>line)
               {if (OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),slippage,clrNONE)) continue;}
               if (Stoploss!=0   && Bid<=OOP - Stoploss   * Point) 
               {if (OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),slippage,clrNONE)) continue;}
               if (Takeprofit!=0 && Bid>=OOP + Takeprofit * Point) 
               {if (OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),slippage,clrNONE)) continue;}
            }                                         
            if (tip==OP_SELL)        
            {
               s++;
               if (Close[1]>line && Open[1]<line)
               {if (OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),slippage,clrNONE)) continue;}
               if (Stoploss!=0   && Ask>=OOP + Stoploss   * Point) 
               {if (OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),slippage,clrNONE)) continue;}
               if (Takeprofit!=0 && Ask<=OOP - Takeprofit * Point) 
               {if (OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),slippage,clrNONE)) continue;}
            } 
         }
      }
   } 

   //-----------------------------------------------------------------------
   if (Close[1]>line && Open[1]<line && b==0)
   {
      if (OrderSend(Symbol(),OP_BUY, Lot,NormalizeDouble(Ask,Digits),slippage,0,0,NULL,Magic,0,clrNONE)==-1)
      Print("   <<",(GetLastError()),">>  ");
   }
   if (Close[1]<line && Open[1]>line && s==0)
   {
      if (OrderSend(Symbol(),OP_SELL,Lot,NormalizeDouble(Bid,Digits),slippage,0,0,NULL,Magic,0,clrNONE)==-1)
      Print("   <<",(GetLastError()),">>  ");
   }
return;
}
//--------------------------------------------------------------------
void OnDeinit(const int reason)
{
   if (!IsTesting()) ObjectsDeleteAll(0,"cm");
   Comment("");
}
//+------------------------------------------------------------------+
